MyGUI: MyGUI::Widget Class Reference

MyGUI 3.4.2

- Main Page
- Related Pages
- Namespaces
- Data Structures
- Files
- Examples

- Data Structures
- Data Structure Index
- Class Hierarchy
- Data Fields

Public Types | Public Member Functions | Static Public Member Functions | Data Fields | Protected Member Functions | Friends
MyGUI::Widget Class Reference

widget description should be here. More...

`#include <MyGUI_Widget.h>`

Inheritance diagram for MyGUI::Widget:
[legend]

## Public Types
typedef RTTIBase | Base
typedef Widget | RTTIBase
Public Types inherited from MyGUI::IObject
typedef IObject | RTTIBase

## Public Member Functions
virtual const std::string & | getTypeName () const override
virtual bool | isType (const std::type_info &_type) const override
template<typename Type >
bool | isType () const
| Widget ()
Widget * | createWidgetT (const std::string &_type, const std::string &_skin, const IntCoord &_coord, Align _align, const std::string &_name="")
Widget * | createWidgetT (const std::string &_type, const std::string &_skin, int _left, int _top, int _width, int _height, Align _align, const std::string &_name="")
Widget * | createWidgetRealT (const std::string &_type, const std::string &_skin, const FloatCoord &_coord, Align _align, const std::string &_name="")
Widget * | createWidgetRealT (const std::string &_type, const std::string &_skin, float _left, float _top, float _width, float _height, Align _align, const std::string &_name="")
template<typename T >
T * | createWidget (const std::string &_skin, const IntCoord &_coord, Align _align, const std::string &_name="")
template<typename T >
T * | createWidget (const std::string &_skin, int _left, int _top, int _width, int _height, Align _align, const std::string &_name="")
template<typename T >
T * | createWidgetReal (const std::string &_skin, const FloatCoord &_coord, Align _align, const std::string &_name="")
template<typename T >
T * | createWidgetReal (const std::string &_skin, float _left, float _top, float _width, float _height, Align _align, const std::string &_name="")
Widget * | createWidgetT (WidgetStyle _style, const std::string &_type, const std::string &_skin, const IntCoord &_coord, Align _align, const std::string &_layer="", const std::string &_name="")
template<typename T >
T * | createWidget (WidgetStyle _style, const std::string &_skin, const IntCoord &_coord, Align _align, const std::string &_layer="", const std::string &_name="")
void | setPosition (const IntPoint &_value) override
void | setSize (const IntSize &_value) override
void | setCoord (const IntCoord &_value) override
void | setPosition (int _left, int _top)
void | setSize (int _width, int _height)
void | setCoord (int _left, int _top, int _width, int _height)
void | setRealPosition (const FloatPoint &_value)
void | setRealSize (const FloatSize &_value)
void | setRealCoord (const FloatCoord &_value)
void | setRealPosition (float _left, float _top)
void | setRealSize (float _width, float _height)
void | setRealCoord (float _left, float _top, float _width, float _height)
const std::string & | getName () const
| Get name of widget.
virtual void | setVisible (bool _value)
bool | getVisible () const
void | setDepth (int _value)
int | getDepth () const
bool | getInheritedVisible () const
virtual void | setAlign (Align _value)
Align | getAlign () const
void | setAlpha (float _value)
float | getAlpha () const
void | setInheritsAlpha (bool _value)
bool | getInheritsAlpha () const
void | setColour (const Colour &_value)
bool | isRootWidget () const
Widget * | getParent () const
IntSize | getParentSize () const
EnumeratorWidgetPtr | getEnumerator () const
size_t | getChildCount () const
Widget * | getChildAt (size_t _index) const
Widget * | findWidget (const std::string &_name)
void | findWidgets (const std::string &_name, VectorWidgetPtr &_result)
virtual void | setEnabled (bool _value)
void | setEnabledSilent (bool _value)
bool | getEnabled () const
bool | getInheritedEnabled () const
IntCoord | getClientCoord () const
Widget * | getClientWidget ()
const Widget * | getClientWidget () const
void | detachFromWidget (const std::string &_layer="")
void | attachToWidget (Widget *_parent, WidgetStyle _style=WidgetStyle::Child, const std::string &_layer="")
void | changeWidgetSkin (const std::string &_skinName)
void | setWidgetStyle (WidgetStyle _style, const std::string &_layer="")
WidgetStyle | getWidgetStyle () const
void | setProperty (const std::string &_key, const std::string &_value)
virtual size_t | _getItemIndex (Widget *_item) const
void | _forcePick (Widget *_widget)
void | _initialise (WidgetStyle _style, const IntCoord &_coord, const std::string &_skinName, Widget *_parent, ICroppedRectangle *_croppedParent, const std::string &_name)
void | _shutdown ()
void | _destroyChildWidget (Widget *_widget)
void | _setContainer (Widget *_value)
Widget * | _getContainer () const
void | _setAlign (const IntSize &_oldsize, const IntSize &_newSize)
bool | _checkPoint (int _left, int _top) const
Widget * | _createSkinWidget (WidgetStyle _style, const std::string &_type, const std::string &_skin, const IntCoord &_coord, Align _align, const std::string &_layer="", const std::string &_name="")
virtual void | _resetContainer (bool _update)
bool | _setWidgetState (const std::string &_value)
void | _updateChilds ()
Public Member Functions inherited from MyGUI::IObject
template<typename Type >
bool | isType () const
template<typename Type >
Type * | castType (bool _throw=true)
template<typename Type >
const Type * | castType (bool _throw=true) const
| IObject ()=default
virtual | ~IObject ()=default
Public Member Functions inherited from MyGUI::ICroppedRectangle
| ICroppedRectangle ()
virtual | ~ICroppedRectangle ()
ICroppedRectangle * | getCroppedParent ()
IntPoint | getPosition () const
IntSize | getSize () const
const IntCoord & | getCoord () const
const IntPoint & | getAbsolutePosition () const
IntRect | getAbsoluteRect () const
IntCoord | getAbsoluteCoord () const
int | getAbsoluteLeft () const
int | getAbsoluteTop () const
int | getLeft () const
int | getRight () const
int | getTop () const
int | getBottom () const
int | getWidth () const
int | getHeight () const
bool | _isMargin () const
int | _getViewLeft () const
int | _getViewRight () const
int | _getViewTop () const
int | _getViewBottom () const
int | _getViewWidth () const
int | _getViewHeight () const
void | _setCroppedParent (ICroppedRectangle *_parent)
const IntRect & | _getMargin () const
int | _getMarginLeft () const
int | _getMarginRight () const
int | _getMarginTop () const
int | _getMarginBottom () const
Public Member Functions inherited from MyGUI::UserData
virtual | ~UserData ()=default
void | setUserString (const std::string &_key, const std::string &_value)
const std::string & | getUserString (const std::string &_key) const
const MapString & | getUserStrings () const
bool | clearUserString (const std::string &_key)
bool | isUserString (const std::string &_key) const
void | clearUserStrings ()
void | setUserData (Any _data)
template<typename ValueType >
ValueType * | getUserData (bool _throw=true) const
void | _setInternalData (Any _data)
template<typename ValueType >
ValueType * | _getInternalData (bool _throw=true) const
Public Member Functions inherited from MyGUI::WidgetInput
| WidgetInput ()
virtual | ~WidgetInput ()=default
void | setNeedToolTip (bool _value)
bool | getNeedToolTip () const
void | setPointer (const std::string &_value)
const std::string & | getPointer () const
void | setNeedKeyFocus (bool _value)
bool | getNeedKeyFocus () const
void | setNeedMouseFocus (bool _value)
bool | getNeedMouseFocus () const
void | setInheritsPick (bool _value)
bool | getInheritsPick () const
void | setMaskPick (const std::string &_filename)
void | setMaskPick (const MaskPickInfo &_info)
bool | isMaskPickInside (const IntPoint &_point, const IntCoord &_coord) const
bool | getRootMouseFocus () const
bool | getRootKeyFocus () const
void | _riseMouseLostFocus (Widget *_new)
void | _riseMouseSetFocus (Widget *_old)
void | _riseMouseDrag (int _left, int _top, MouseButton _id)
void | _riseMouseMove (int _left, int _top)
void | _riseMouseWheel (int _rel)
void | _riseMouseButtonPressed (int _left, int _top, MouseButton _id)
void | _riseMouseButtonReleased (int _left, int _top, MouseButton _id)
void | _riseMouseButtonClick ()
void | _riseMouseButtonDoubleClick ()
void | _riseKeyLostFocus (Widget *_new)
void | _riseKeySetFocus (Widget *_old)
void | _riseKeyButtonPressed (KeyCode _key, Char _char)
void | _riseKeyButtonReleased (KeyCode _key)
void | _riseMouseChangeRootFocus (bool _focus)
void | _riseKeyChangeRootFocus (bool _focus)
void | _setRootMouseFocus (bool _value)
void | _setRootKeyFocus (bool _value)
Public Member Functions inherited from MyGUI::delegates::IDelegateUnlink
virtual | ~IDelegateUnlink ()=default
| IDelegateUnlink ()
bool | compare (IDelegateUnlink *_unlink) const
Public Member Functions inherited from MyGUI::SkinItem
| SkinItem ()
ISubWidgetText * | getSubWidgetText () const
ISubWidgetRect * | getSubWidgetMain () const
void | _setTextureName (const std::string &_texture)
const std::string & | _getTextureName () const
Public Member Functions inherited from MyGUI::LayerItem
| LayerItem ()
ILayer * | getLayer () const
ILayerNode * | getLayerNode () const
void | attachItemToNode (ILayer *_layer, ILayerNode *_node) override
void | detachFromLayer () override
void | upLayerItem () override
void | setRenderItemTexture (ITexture *_texture)
void | addChildItem (LayerItem *_item)
void | removeChildItem (LayerItem *_item)
void | addChildNode (LayerItem *_item)
void | removeChildNode (LayerItem *_item)
void | addRenderItem (ISubWidget *_item)
void | removeAllRenderItems ()
void | saveLayerItem ()
void | restoreLayerItem ()
Public Member Functions inherited from MyGUI::ILayerItem
virtual | ~ILayerItem ()
Public Member Functions inherited from MyGUI::MemberObsolete< Widget >
bool | isEnabled ()
bool | isInheritsAlpha ()
bool | isNeedKeyFocus ()
bool | isNeedMouseFocus ()
bool | isInheritsPick ()
bool | isVisible ()

## Static Public Member Functions
static const std::string & | getClassTypeName ()
Static Public Member Functions inherited from MyGUI::IObject
static const std::string & | getClassTypeName ()

## Data Fields
EventHandle_WidgetStringString | eventChangeProperty
EventHandle_WidgetVoid | eventChangeCoord
EventHandle_WidgetVoid | eventWidgetDestroyed
Data Fields inherited from MyGUI::WidgetInput
EventHandle_WidgetWidget | eventMouseLostFocus
EventHandle_WidgetWidget | eventMouseSetFocus
EventPairAddParameter< EventHandle_WidgetIntInt, EventHandle_WidgetIntIntButton > | eventMouseDrag
EventHandle_WidgetIntInt | eventMouseMove
EventHandle_WidgetInt | eventMouseWheel
EventHandle_WidgetIntIntButton | eventMouseButtonPressed
EventHandle_WidgetIntIntButton | eventMouseButtonReleased
EventHandle_WidgetVoid | eventMouseButtonClick
EventHandle_WidgetVoid | eventMouseButtonDoubleClick
EventHandle_WidgetWidget | eventKeyLostFocus
EventHandle_WidgetWidget | eventKeySetFocus
EventHandle_WidgetKeyCodeChar | eventKeyButtonPressed
EventHandle_WidgetKeyCode | eventKeyButtonReleased
EventHandle_WidgetBool | eventRootMouseChangeFocus
EventHandle_WidgetBool | eventRootKeyChangeFocus
EventHandle_WidgetToolTip | eventToolTip

## Protected Member Functions
| ~Widget () override=default
virtual void | shutdownOverride ()
virtual void | initialiseOverride ()
void | _updateView ()
Widget * | baseCreateWidget (WidgetStyle _style, const std::string &_type, const std::string &_skin, const IntCoord &_coord, Align _align, const std::string &_layer, const std::string &_name, bool _template)
void | _destroyAllChildWidget ()
virtual size_t | _getContainerIndex (const IntPoint &_point) const
virtual void | baseUpdateEnable ()
ILayerItem * | getLayerItemByPoint (int _left, int _top) const override
const IntCoord & | getLayerItemCoord () const override
template<typename T >
void | assignWidget (T *&_widget, const std::string &_name)
VectorWidgetPtr | getSkinWidgetsByName (const std::string &_name) const
virtual void | onWidgetCreated (Widget *_widget)
virtual void | onWidgetDestroy (Widget *_widget)
void | setWidgetClient (Widget *_widget)
Widget * | _getClientWidget ()
| If there is client widget return it, otherwise return this.
const Widget * | _getClientWidget () const
virtual void | setPropertyOverride (const std::string &_key, const std::string &_value)
Protected Member Functions inherited from MyGUI::ICroppedRectangle
bool | _checkMargin ()
bool | _checkOutside () const
Protected Member Functions inherited from MyGUI::WidgetInput
virtual void | onMouseLostFocus (Widget *_new)
virtual void | onMouseSetFocus (Widget *_old)
virtual void | onMouseDrag (int _left, int _top, MouseButton _id)
virtual void | onMouseMove (int _left, int _top)
virtual void | onMouseWheel (int _rel)
virtual void | onMouseButtonPressed (int _left, int _top, MouseButton _id)
virtual void | onMouseButtonReleased (int _left, int _top, MouseButton _id)
virtual void | onMouseButtonClick ()
virtual void | onMouseButtonDoubleClick ()
virtual void | onKeyLostFocus (Widget *_new)
virtual void | onKeySetFocus (Widget *_old)
virtual void | onKeyButtonPressed (KeyCode _key, Char _char)
virtual void | onKeyButtonReleased (KeyCode _key)
virtual void | onMouseChangeRootFocus (bool _focus)
virtual void | onKeyChangeRootFocus (bool _focus)
Protected Member Functions inherited from MyGUI::SkinItem
void | _createSkinItem (ResourceSkin *_info)
void | _deleteSkinItem ()
void | _setSkinItemAlign (const IntSize &_size)
void | _setSkinItemVisible (bool _value)
void | _setSkinItemColour (const Colour &_value)
void | _setSkinItemAlpha (float _value)
void | _correctSkinItemView ()
void | _updateSkinItemView ()
bool | _setSkinItemState (const std::string &_state)
void | _setSubSkinVisible (bool _visible)
Protected Member Functions inherited from MyGUI::LayerItem
void | attachToLayerItemNode (ILayerNode *_node, bool _deep)
void | detachFromLayerItemNode (bool _deep)

## Friends
class | WidgetManager

## Additional Inherited Members
Protected Attributes inherited from MyGUI::ICroppedRectangle
IntRect | mMargin
IntCoord | mCoord
IntPoint | mAbsolutePosition
bool | mIsMargin
ICroppedRectangle * | mCroppedParent

## Detailed Description

widget description should be here.

Definition at line 29 of file MyGUI_Widget.h.

## Member Typedef Documentation

## ◆ Base

RTTIBase MyGUI::Widget::Base

Definition at line 41 of file MyGUI_Widget.h.

## ◆ RTTIBase

Widget MyGUI::Widget::RTTIBase

Definition at line 41 of file MyGUI_Widget.h.

## Constructor & Destructor Documentation

## ◆ Widget()

MyGUI::Widget::Widget | ( |  | ) |

Definition at line 31 of file MyGUI_Widget.cpp.

## ◆ ~Widget()

MyGUI::Widget::~Widget | ( |  | ) |
| overrideprotecteddefault

## Member Function Documentation

## ◆ _checkPoint()

bool MyGUI::Widget::_checkPoint | ( | int | _left,
|  | int | _top ) const

Definition at line 1035 of file MyGUI_Widget.cpp.

## ◆ _createSkinWidget()

Widget * MyGUI::Widget::_createSkinWidget | ( | WidgetStyle | _style,
|  | const std::string & | _type,
|  | const std::string & | _skin,
|  | const IntCoord & | _coord,
|  | Align | _align,
|  | const std::string & | _layer = "",
|  | const std::string & | _name = "" )

Definition at line 1139 of file MyGUI_Widget.cpp.

## ◆ _destroyAllChildWidget()

void MyGUI::Widget::_destroyAllChildWidget | ( |  | ) |
| protected

Definition at line 410 of file MyGUI_Widget.cpp.

## ◆ _destroyChildWidget()

void MyGUI::Widget::_destroyChildWidget | ( | Widget * | _widget | ) |

Definition at line 379 of file MyGUI_Widget.cpp.

## ◆ _forcePick()

void MyGUI::Widget::_forcePick | ( | Widget * | _widget | ) |

Definition at line 515 of file MyGUI_Widget.cpp.

## ◆ _getClientWidget() [1/2]

Widget * MyGUI::Widget::_getClientWidget | ( |  | ) |
| protected

If there is client widget return it, otherwise return this.

Definition at line 1129 of file MyGUI_Widget.cpp.

## ◆ _getClientWidget() [2/2]

const Widget * MyGUI::Widget::_getClientWidget | ( |  | ) | const
| protected

Definition at line 1134 of file MyGUI_Widget.cpp.

## ◆ _getContainer()

Widget * MyGUI::Widget::_getContainer | ( |  | ) | const

Definition at line 1315 of file MyGUI_Widget.cpp.

## ◆ _getContainerIndex()

size_t MyGUI::Widget::_getContainerIndex | ( | const IntPoint & | _point | ) | const
| protectedvirtual

Reimplemented in MyGUI::ItemBox.

Definition at line 1320 of file MyGUI_Widget.cpp.

## ◆ _getItemIndex()

size_t MyGUI::Widget::_getItemIndex | ( | Widget * | _item | ) | const
| virtual

Reimplemented in MyGUI::ItemBox, and MyGUI::ListBox.

Definition at line 1305 of file MyGUI_Widget.cpp.

## ◆ _initialise()

void MyGUI::Widget::_initialise | ( | WidgetStyle | _style,
|  | const IntCoord & | _coord,
|  | const std::string & | _skinName,
|  | Widget * | _parent,
|  | ICroppedRectangle * | _croppedParent,
|  | const std::string & | _name )

Definition at line 48 of file MyGUI_Widget.cpp.

## ◆ _resetContainer()

void MyGUI::Widget::_resetContainer | ( | bool | _update | ) |
| virtual

Reimplemented in MyGUI::ComboBox, MyGUI::ItemBox, and MyGUI::ListBox.

Definition at line 1029 of file MyGUI_Widget.cpp.

## ◆ _setAlign()

void MyGUI::Widget::_setAlign | ( | const IntSize & | _oldsize,
|  | const IntSize & | _newSize )

Definition at line 568 of file MyGUI_Widget.cpp.

## ◆ _setContainer()

void MyGUI::Widget::_setContainer | ( | Widget * | _value | ) |

Definition at line 1310 of file MyGUI_Widget.cpp.

## ◆ _setWidgetState()

bool MyGUI::Widget::_setWidgetState | ( | const std::string & | _value | ) |

Definition at line 374 of file MyGUI_Widget.cpp.

## ◆ _shutdown()

void MyGUI::Widget::_shutdown | ( |  | ) |

Definition at line 123 of file MyGUI_Widget.cpp.

## ◆ _updateChilds()

void MyGUI::Widget::_updateChilds | ( |  | ) |

Definition at line 1390 of file MyGUI_Widget.cpp.

## ◆ _updateView()

void MyGUI::Widget::_updateView | ( |  | ) |
| protected

Definition at line 327 of file MyGUI_Widget.cpp.

## ◆ assignWidget()

template<typename T >

void MyGUI::Widget::assignWidget | ( | T *& | _widget,
|  | const std::string & | _name )
| inlineprotected

Definition at line 336 of file MyGUI_Widget.h.

## ◆ attachToWidget()

void MyGUI::Widget::attachToWidget | ( | Widget * | _parent,
|  | WidgetStyle | _style = WidgetStyle::Child,
|  | const std::string & | _layer = "" )

Attach widget to parent

Parameters

  _parent | New parent
  _style | New widget style (see WidgetStyle::Enum)
  _layer | Attach to specified layer (if any)

Definition at line 798 of file MyGUI_Widget.cpp.

## ◆ baseCreateWidget()

Widget * MyGUI::Widget::baseCreateWidget | ( | WidgetStyle | _style,
|  | const std::string & | _type,
|  | const std::string & | _skin,
|  | const IntCoord & | _coord,
|  | Align | _align,
|  | const std::string & | _layer,
|  | const std::string & | _name,
|  | bool | _template )
| protected

Definition at line 287 of file MyGUI_Widget.cpp.

## ◆ baseUpdateEnable()

void MyGUI::Widget::baseUpdateEnable | ( |  | ) |
| protectedvirtual

Reimplemented in MyGUI::Button.

Definition at line 951 of file MyGUI_Widget.cpp.

## ◆ changeWidgetSkin()

void MyGUI::Widget::changeWidgetSkin | ( | const std::string & | _skinName | ) |

Change widget skin

Definition at line 154 of file MyGUI_Widget.cpp.

## ◆ createWidget() [1/3]

template<typename T >

T * MyGUI::Widget::createWidget | ( | const std::string & | _skin,
|  | const IntCoord & | _coord,
|  | Align | _align,
|  | const std::string & | _name = "" )
| inline

Same as Widget::createWidgetT but return T pointer instead of Widget*

Definition at line 67 of file MyGUI_Widget.h.

## ◆ createWidget() [2/3]

template<typename T >

T * MyGUI::Widget::createWidget | ( | const std::string & | _skin,
|  | int | _left,
|  | int | _top,
|  | int | _width,
|  | int | _height,
|  | Align | _align,
|  | const std::string & | _name = "" )
| inline

Same as Widget::createWidgetT but return T pointer instead of Widget*

Definition at line 74 of file MyGUI_Widget.h.

## ◆ createWidget() [3/3]

template<typename T >

T * MyGUI::Widget::createWidget | ( | WidgetStyle | _style,
|  | const std::string & | _skin,
|  | const IntCoord & | _coord,
|  | Align | _align,
|  | const std::string & | _layer = "",
|  | const std::string & | _name = "" )
| inline

Same as Widget::createWidgetT but return T* instead of Widget*

Definition at line 106 of file MyGUI_Widget.h.

## ◆ createWidgetReal() [1/2]

template<typename T >

T * MyGUI::Widget::createWidgetReal | ( | const std::string & | _skin,
|  | const FloatCoord & | _coord,
|  | Align | _align,
|  | const std::string & | _name = "" )
| inline

Same as Widget::createWidgetRealT but return T* instead of Widget*

Definition at line 81 of file MyGUI_Widget.h.

## ◆ createWidgetReal() [2/2]

template<typename T >

T * MyGUI::Widget::createWidgetReal | ( | const std::string & | _skin,
|  | float | _left,
|  | float | _top,
|  | float | _width,
|  | float | _height,
|  | Align | _align,
|  | const std::string & | _name = "" )
| inline

Same as Widget::createWidgetRealT but return T* instead of Widget*

Definition at line 88 of file MyGUI_Widget.h.

## ◆ createWidgetRealT() [1/2]

Widget * MyGUI::Widget::createWidgetRealT | ( | const std::string & | _type,
|  | const std::string & | _skin,
|  | const FloatCoord & | _coord,
|  | Align | _align,
|  | const std::string & | _name = "" )

Create widget using coordinates relative to parent. see Widget::createWidgetT(const std::string& _type, const std::string& _skin, const IntCoord& _coord, Align _align, const std::string& _name = "")

Definition at line 322 of file MyGUI_Widget.cpp.

## ◆ createWidgetRealT() [2/2]

Widget * MyGUI::Widget::createWidgetRealT | ( | const std::string & | _type,
|  | const std::string & | _skin,
|  | float | _left,
|  | float | _top,
|  | float | _width,
|  | float | _height,
|  | Align | _align,
|  | const std::string & | _name = "" )

Create widget using coordinates relative to parent. see Widget::createWidgetT(const std::string& _type, const std::string& _skin, const IntCoord& _coord, Align _align, const std::string& _name = "")

Definition at line 919 of file MyGUI_Widget.cpp.

## ◆ createWidgetT() [1/3]

Widget * MyGUI::Widget::createWidgetT | ( | const std::string & | _type,
|  | const std::string & | _skin,
|  | const IntCoord & | _coord,
|  | Align | _align,
|  | const std::string & | _name = "" )

Create child widget

Parameters

  _type | widget type
  _skin | widget skin
  _coord | int coordinates of widget (_left, _top, _width, _height)
  _align | widget align (possible values can be found in enum Align)
  _name | if needed (you can use it for finding widget by name later)

Definition at line 909 of file MyGUI_Widget.cpp.

## ◆ createWidgetT() [2/3]

Widget * MyGUI::Widget::createWidgetT | ( | const std::string & | _type,
|  | const std::string & | _skin,
|  | int | _left,
|  | int | _top,
|  | int | _width,
|  | int | _height,
|  | Align | _align,
|  | const std::string & | _name = "" )

See Widget::createWidgetT(const std::string& _type, const std::string& _skin, const IntCoord& _coord, Align _align, const std::string& _name = "")

Definition at line 914 of file MyGUI_Widget.cpp.

## ◆ createWidgetT() [3/3]

Widget * MyGUI::Widget::createWidgetT | ( | WidgetStyle | _style,
|  | const std::string & | _type,
|  | const std::string & | _skin,
|  | const IntCoord & | _coord,
|  | Align | _align,
|  | const std::string & | _layer = "",
|  | const std::string & | _name = "" )

Create child widget

Parameters

  _style | Child, Popup or Overlapped widget style
  _type | widget type
  _skin | widget skin
  _coord | int coordinates of widget (_left, _top, _width, _height)
  _align | widget align (possible values can be found in enum Align)
  _layer | layer where widget will be created (all layers usually defined in core_layer.xml file).
  _name | optional widget name (you can use it for finding widget by name later)

Definition at line 924 of file MyGUI_Widget.cpp.

## ◆ detachFromWidget()

void MyGUI::Widget::detachFromWidget | ( | const std::string & | _layer = "" | ) |

Detach widget from widgets hierarchy

Parameters

  _layer | Attach to specified layer (if any)

Definition at line 736 of file MyGUI_Widget.cpp.

## ◆ findWidget()

Widget * MyGUI::Widget::findWidget | ( | const std::string & | _name | ) |

Find widget by name. Search recursively through all childs starting from this widget.

Returns
  Return first found widget with given name

Definition at line 537 of file MyGUI_Widget.cpp.

## ◆ findWidgets()

void MyGUI::Widget::findWidgets | ( | const std::string & | _name,
|  | VectorWidgetPtr & | _result )

Find all widgets with given name and add them into _result. Search recursively through all childs starting from this widget.

Definition at line 1099 of file MyGUI_Widget.cpp.

## ◆ getAlign()

Align MyGUI::Widget::getAlign | ( |  | ) | const

Get align

Definition at line 1255 of file MyGUI_Widget.cpp.

## ◆ getAlpha()

float MyGUI::Widget::getAlpha | ( |  | ) | const

Get widget opacity

Definition at line 1260 of file MyGUI_Widget.cpp.

## ◆ getChildAt()

Widget * MyGUI::Widget::getChildAt | ( | size_t | _index | ) | const

Get child by index (index from 0 to child_count - 1)

Definition at line 943 of file MyGUI_Widget.cpp.

## ◆ getChildCount()

size_t MyGUI::Widget::getChildCount | ( |  | ) | const

Get child count

Definition at line 936 of file MyGUI_Widget.cpp.

## ◆ getClassTypeName()

static const std::string & MyGUI::Widget::getClassTypeName | ( |  | ) |
| inlinestatic

Definition at line 41 of file MyGUI_Widget.h.

## ◆ getClientCoord()

IntCoord MyGUI::Widget::getClientCoord | ( |  | ) | const

Get rectangle where child widgets placed

Definition at line 427 of file MyGUI_Widget.cpp.

## ◆ getClientWidget() [1/2]

Widget * MyGUI::Widget::getClientWidget | ( |  | ) |

Get client area widget or nullptr if widget don't have client

Definition at line 1290 of file MyGUI_Widget.cpp.

## ◆ getClientWidget() [2/2]

const Widget * MyGUI::Widget::getClientWidget | ( |  | ) | const

Definition at line 1295 of file MyGUI_Widget.cpp.

## ◆ getDepth()

int MyGUI::Widget::getDepth | ( |  | ) | const

Get child widget rendering depth

Definition at line 1365 of file MyGUI_Widget.cpp.

## ◆ getEnabled()

bool MyGUI::Widget::getEnabled | ( |  | ) | const

Is widget enabled

Definition at line 1285 of file MyGUI_Widget.cpp.

## ◆ getEnumerator()

EnumeratorWidgetPtr MyGUI::Widget::getEnumerator | ( |  | ) | const

Get child widgets Enumerator

Definition at line 929 of file MyGUI_Widget.cpp.

## ◆ getInheritedEnabled()

bool MyGUI::Widget::getInheritedEnabled | ( |  | ) | const

Is widget enabled and all it's parents in hierarchy are enabled.

Definition at line 1335 of file MyGUI_Widget.cpp.

## ◆ getInheritedVisible()

bool MyGUI::Widget::getInheritedVisible | ( |  | ) | const

Return widget's visibility based on it's and parents visibility.

Definition at line 1340 of file MyGUI_Widget.cpp.

## ◆ getInheritsAlpha()

bool MyGUI::Widget::getInheritsAlpha | ( |  | ) | const

Get inherits alpha mode flag

Definition at line 1265 of file MyGUI_Widget.cpp.

## ◆ getLayerItemByPoint()

ILayerItem * MyGUI::Widget::getLayerItemByPoint | ( | int | _left,
|  | int | _top ) const
| overrideprotectedvirtual

Implements MyGUI::ILayerItem.

Definition at line 464 of file MyGUI_Widget.cpp.

## ◆ getLayerItemCoord()

const IntCoord & MyGUI::Widget::getLayerItemCoord | ( |  | ) | const
| overrideprotectedvirtual

Implements MyGUI::ILayerItem.

Definition at line 1325 of file MyGUI_Widget.cpp.

## ◆ getName()

const std::string & MyGUI::Widget::getName | ( |  | ) | const

Get name of widget.

Definition at line 1245 of file MyGUI_Widget.cpp.

## ◆ getParent()

Widget * MyGUI::Widget::getParent | ( |  | ) | const

Get parent widget or nullptr if no parent

Definition at line 1275 of file MyGUI_Widget.cpp.

## ◆ getParentSize()

IntSize MyGUI::Widget::getParentSize | ( |  | ) | const

Get parent widget size. If there is no parent get layer size

Definition at line 1019 of file MyGUI_Widget.cpp.

## ◆ getSkinWidgetsByName()

VectorWidgetPtr MyGUI::Widget::getSkinWidgetsByName | ( | const std::string & | _name | ) | const
| protected

Definition at line 1089 of file MyGUI_Widget.cpp.

## ◆ getTypeName()

virtual const std::string & MyGUI::Widget::getTypeName | ( |  | ) | const
| inlineoverridevirtual

Get type name as string

Reimplemented from MyGUI::IObject.

Reimplemented in MyGUI::Button, MyGUI::Canvas, MyGUI::ComboBox, MyGUI::DDContainer, MyGUI::EditBox, MyGUI::HScroll, MyGUI::ImageBox, MyGUI::ItemBox, MyGUI::ListBox, MyGUI::MenuBar, MyGUI::MenuControl, MyGUI::MenuItem, MyGUI::MultiListBox, MyGUI::MultiListItem, MyGUI::PopupMenu, MyGUI::ProgressBar, MyGUI::ScrollBar, MyGUI::ScrollView, MyGUI::TabControl, MyGUI::TabItem, MyGUI::TextBox, MyGUI::VScroll, and MyGUI::Window.

Definition at line 41 of file MyGUI_Widget.h.

## ◆ getVisible()

bool MyGUI::Widget::getVisible | ( |  | ) | const

Return true if visible

Definition at line 1250 of file MyGUI_Widget.cpp.

## ◆ getWidgetStyle()

WidgetStyle MyGUI::Widget::getWidgetStyle | ( |  | ) | const

Get widget style

Definition at line 1300 of file MyGUI_Widget.cpp.

## ◆ initialiseOverride()

void MyGUI::Widget::initialiseOverride | ( |  | ) |
| protectedvirtual

Reimplemented in MyGUI::Button, MyGUI::Canvas, MyGUI::ComboBox, MyGUI::EditBox, MyGUI::ItemBox, MyGUI::ListBox, MyGUI::MenuControl, MyGUI::MenuItem, MyGUI::MultiListBox, MyGUI::MultiListItem, MyGUI::ProgressBar, MyGUI::ScrollBar, MyGUI::ScrollView, MyGUI::TabControl, MyGUI::TabItem, and MyGUI::Window.

Definition at line 1058 of file MyGUI_Widget.cpp.

## ◆ isRootWidget()

bool MyGUI::Widget::isRootWidget | ( |  | ) | const

Is this widget is root widget (root == without parents)

Definition at line 1270 of file MyGUI_Widget.cpp.

## ◆ isType() [1/2]

template<typename Type >

bool MyGUI::Widget::isType | ( |  | ) | const
| inline

Compare with selected type

Definition at line 41 of file MyGUI_Widget.h.

## ◆ isType() [2/2]

virtual bool MyGUI::Widget::isType | ( | const std::type_info & | _type | ) | const
| inlineoverridevirtual

Compare with selected type

Reimplemented from MyGUI::IObject.

Reimplemented in MyGUI::Button, MyGUI::Canvas, MyGUI::ComboBox, MyGUI::DDContainer, MyGUI::EditBox, MyGUI::HScroll, MyGUI::ImageBox, MyGUI::ItemBox, MyGUI::ListBox, MyGUI::MenuBar, MyGUI::MenuControl, MyGUI::MenuItem, MyGUI::MultiListBox, MyGUI::MultiListItem, MyGUI::PopupMenu, MyGUI::ProgressBar, MyGUI::ScrollBar, MyGUI::ScrollView, MyGUI::TabControl, MyGUI::TabItem, MyGUI::TextBox, MyGUI::VScroll, and MyGUI::Window.

Definition at line 41 of file MyGUI_Widget.h.

## ◆ onWidgetCreated()

void MyGUI::Widget::onWidgetCreated | ( | Widget * | _widget | ) |
| protectedvirtual

Reimplemented in MyGUI::MenuControl, MyGUI::MenuItem, MyGUI::MultiListBox, and MyGUI::TabControl.

Definition at line 1115 of file MyGUI_Widget.cpp.

## ◆ onWidgetDestroy()

void MyGUI::Widget::onWidgetDestroy | ( | Widget * | _widget | ) |
| protectedvirtual

Reimplemented in MyGUI::MultiListBox.

Definition at line 1119 of file MyGUI_Widget.cpp.

## ◆ setAlign()

void MyGUI::Widget::setAlign | ( | Align | _value | ) |
| virtual

Set align

Definition at line 731 of file MyGUI_Widget.cpp.

## ◆ setAlpha()

void MyGUI::Widget::setAlpha | ( | float | _value | ) |

Set widget opacity

Definition at line 434 of file MyGUI_Widget.cpp.

## ◆ setColour()

void MyGUI::Widget::setColour | ( | const Colour & | _value | ) |

Definition at line 1011 of file MyGUI_Widget.cpp.

## ◆ setCoord() [1/2]

void MyGUI::Widget::setCoord | ( | const IntCoord & | _value | ) |
| overridevirtual

Set widget position and size

Reimplemented from MyGUI::ICroppedRectangle.

Reimplemented in MyGUI::Window.

Definition at line 686 of file MyGUI_Widget.cpp.

## ◆ setCoord() [2/2]

void MyGUI::Widget::setCoord | ( | int | _left,
|  | int | _top,
|  | int | _width,
|  | int | _height )

See Widget::setCoord(const IntCoord& _coord)

Definition at line 1225 of file MyGUI_Widget.cpp.

## ◆ setDepth()

void MyGUI::Widget::setDepth | ( | int | _value | ) |

Set child widget rendering depth for ordering child widgets. Widget with higher depth is rendered below widget with lower depth. Available only for child widgets. For root widgets use layer property instead.

Definition at line 1350 of file MyGUI_Widget.cpp.

## ◆ setEnabled()

void MyGUI::Widget::setEnabled | ( | bool | _value | ) |
| virtual

Enable or disable widget

Definition at line 986 of file MyGUI_Widget.cpp.

## ◆ setEnabledSilent()

void MyGUI::Widget::setEnabledSilent | ( | bool | _value | ) |

Enable or disable widget without changing widget's state

Definition at line 1280 of file MyGUI_Widget.cpp.

## ◆ setInheritsAlpha()

void MyGUI::Widget::setInheritsAlpha | ( | bool | _value | ) |

Enable or disable inherits alpha mode.
Inherits alpha mode: when enabled widget alpha is it's own alpha value multiplied by parent's real alpha (that depend on parent's parent and so on).
When disabled widget's alpha doesn't depend on parent's alpha. So this is used when you need things like semi-transparent window with non-transparent text on it and window's alpha changes.
Enabled (true) by default.

Definition at line 458 of file MyGUI_Widget.cpp.

## ◆ setPosition() [1/2]

void MyGUI::Widget::setPosition | ( | const IntPoint & | _value | ) |
| overridevirtual

Set widget position (position of left top corner)

Reimplemented from MyGUI::ICroppedRectangle.

Reimplemented in MyGUI::Window.

Definition at line 632 of file MyGUI_Widget.cpp.

## ◆ setPosition() [2/2]

void MyGUI::Widget::setPosition | ( | int | _left,
|  | int | _top )

See Widget::setPosition(const IntPoint& _pos)

Definition at line 1215 of file MyGUI_Widget.cpp.

## ◆ setProperty()

void MyGUI::Widget::setProperty | ( | const std::string & | _key,
|  | const std::string & | _value )

Set any widget property

Parameters

  _key | Property name (for example Alpha or Enabled)
  _value | Value converted to string

Definition at line 1071 of file MyGUI_Widget.cpp.

## ◆ setPropertyOverride()

void MyGUI::Widget::setPropertyOverride | ( | const std::string & | _key,
|  | const std::string & | _value )
| protectedvirtual

Reimplemented in MyGUI::Button, MyGUI::ComboBox, MyGUI::DDContainer, MyGUI::EditBox, MyGUI::ImageBox, MyGUI::ItemBox, MyGUI::ListBox, MyGUI::MenuControl, MyGUI::MenuItem, MyGUI::MultiListItem, MyGUI::ProgressBar, MyGUI::ScrollBar, MyGUI::ScrollView, MyGUI::TabControl, MyGUI::TabItem, MyGUI::TextBox, and MyGUI::Window.

Definition at line 1144 of file MyGUI_Widget.cpp.

## ◆ setRealCoord() [1/2]

void MyGUI::Widget::setRealCoord | ( | const FloatCoord & | _value | ) |

Set widget position and size

Definition at line 563 of file MyGUI_Widget.cpp.

## ◆ setRealCoord() [2/2]

void MyGUI::Widget::setRealCoord | ( | float | _left,
|  | float | _top,
|  | float | _width,
|  | float | _height )

See Widget::setRealPosition(const FloatCoord& _coord)

Definition at line 1240 of file MyGUI_Widget.cpp.

## ◆ setRealPosition() [1/2]

void MyGUI::Widget::setRealPosition | ( | const FloatPoint & | _value | ) |

Set widget position (position of left top corner)

Definition at line 553 of file MyGUI_Widget.cpp.

## ◆ setRealPosition() [2/2]

void MyGUI::Widget::setRealPosition | ( | float | _left,
|  | float | _top )

See Widget::setRealPosition(const FloatPoint& _point)

Definition at line 1230 of file MyGUI_Widget.cpp.

## ◆ setRealSize() [1/2]

void MyGUI::Widget::setRealSize | ( | const FloatSize & | _value | ) |

Set widget size

Definition at line 558 of file MyGUI_Widget.cpp.

## ◆ setRealSize() [2/2]

void MyGUI::Widget::setRealSize | ( | float | _width,
|  | float | _height )

See Widget::setRealSize(const FloatSize& _size)

Definition at line 1235 of file MyGUI_Widget.cpp.

## ◆ setSize() [1/2]

void MyGUI::Widget::setSize | ( | const IntSize & | _value | ) |
| overridevirtual

Set widget size

Reimplemented from MyGUI::ICroppedRectangle.

Reimplemented in MyGUI::Window.

Definition at line 649 of file MyGUI_Widget.cpp.

## ◆ setSize() [2/2]

void MyGUI::Widget::setSize | ( | int | _width,
|  | int | _height )

See Widget::setSize(const IntSize& _size)

Definition at line 1220 of file MyGUI_Widget.cpp.

## ◆ setVisible()

void MyGUI::Widget::setVisible | ( | bool | _value | ) |
| virtual

Hide or show widget

Reimplemented in MyGUI::MenuControl, and MyGUI::Window.

Definition at line 959 of file MyGUI_Widget.cpp.

## ◆ setWidgetClient()

void MyGUI::Widget::setWidgetClient | ( | Widget * | _widget | ) |
| protected

Definition at line 1123 of file MyGUI_Widget.cpp.

## ◆ setWidgetStyle()

void MyGUI::Widget::setWidgetStyle | ( | WidgetStyle | _style,
|  | const std::string & | _layer = "" )

Set widget style.

Parameters

  _style | New widget style (see WidgetStyle::Enum)
  _layer | Attach to specified layer (if any)

Note
  When choosing WidgetStyle::Popup style you also need attach widget to layer

Definition at line 895 of file MyGUI_Widget.cpp.

## ◆ shutdownOverride()

void MyGUI::Widget::shutdownOverride | ( |  | ) |
| protectedvirtual

Reimplemented in MyGUI::Button, MyGUI::Canvas, MyGUI::ComboBox, MyGUI::EditBox, MyGUI::ImageBox, MyGUI::ItemBox, MyGUI::ListBox, MyGUI::MenuControl, MyGUI::MenuItem, MyGUI::MultiListBox, MyGUI::MultiListItem, MyGUI::ProgressBar, MyGUI::ScrollBar, MyGUI::ScrollView, MyGUI::TabControl, MyGUI::TabItem, and MyGUI::Window.

Definition at line 1054 of file MyGUI_Widget.cpp.

## Friends And Related Symbol Documentation

## ◆ WidgetManager

friend class WidgetManager
| friend

Definition at line 39 of file MyGUI_Widget.h.

## Field Documentation

## ◆ eventChangeCoord

EventHandle_WidgetVoid MyGUI::Widget::eventChangeCoord

Event : Widget coordinate changed (widget was resized or moved).
signature : void method(MyGUI::Widget* _sender)

Parameters

  _sender | widget that called this event

Definition at line 274 of file MyGUI_Widget.h.

## ◆ eventChangeProperty

EventHandle_WidgetStringString MyGUI::Widget::eventChangeProperty

Event : Widget property changed through setProperty (in code, or from layout)
signature : void method(MyGUI::Widget* _sender, const std::string& _key, const std::string& _value);

Parameters

  _sender | widget that called this event
  _key |
  _value |

Definition at line 268 of file MyGUI_Widget.h.

## ◆ eventWidgetDestroyed

EventHandle_WidgetVoid MyGUI::Widget::eventWidgetDestroyed

Event : Widget is about to be destroyed, but its content is valid at this point.
signature : void method(MyGUI::Widget* _sender)

Parameters

  _sender | widget that called this event

Definition at line 280 of file MyGUI_Widget.h.

The documentation for this class was generated from the following files:

- MyGUI_Widget.h
- MyGUI_Widget.cpp